//+------------------------------------------------------------------+
//|                                                             HT   |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window


extern string infoa       = " mode settings ";
extern string info1       = " 1 = period of Dominant Cycle";
extern string info2       = " 2 = Amplitude of Dominant Cycle";
extern string info3       = " 3 = Phase of Dominant Cycle";
extern int    mode        = 1;
extern bool   unfiltered  = false; //discrete=false
extern int    linewidth   = 4;  




double ht[];
double domcycle[];
double damp[];
double dphase[];
double JL; 
double JG; 
double I2[2];
double Q2[2];
double Re[2];
double Im[2];
double I1[7];
double Q1[7];
double smooth[7];
double detrend[7];



string shortname = "HT";




int init() 
{


      IndicatorBuffers(4);
      IndicatorDigits(1);
      SetIndexBuffer(0, ht); SetIndexStyle(0, DRAW_LINE);
      SetIndexBuffer(1, domcycle);
      SetIndexBuffer(2, damp);
      SetIndexBuffer(3, dphase);
   
   if (mode == 1) {
      IndicatorDigits(1);
      SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,linewidth,LimeGreen);
      SetIndexLabel(0, "DominantCycle");
      IndicatorShortName(shortname + "DominantCycle");
   }
   if (mode == 2) {
      IndicatorDigits(2);
      SetIndexStyle(0, DRAW_LINE,STYLE_SOLID,linewidth,Aqua);
      SetIndexLabel(0, "Amplitude");
      IndicatorShortName(shortname + "Amplitude");
   }
   if (mode == 3) {
      IndicatorDigits(2);
      SetIndexStyle(0, DRAW_LINE,STYLE_SOLID,linewidth,Red);
      SetIndexLabel(0, "Phase");
      IndicatorShortName(shortname + "Phase");
   }
   
   return (0);
}



int deinit(){return (0);}

int start() {
   
   double Pi = 3.14159265358979323846264338327950288;
   
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   for(i=limit; i>=0; i--)
   {
   
      I2[1]      = I2[0];
      Q2[1]      = Q2[0];
      Re[1]      = Re[0];
      Im[1]      = Im[0];
      I1[6]      = I1[5];
      I1[5]      = I1[4];
      I1[4]      = I1[3];
      I1[3]      = I1[2];
      I1[2]      = I1[1];
      I1[1]      = I1[0];
      Q1[6]      = Q1[5];
      Q1[5]      = Q1[4];
      Q1[4]      = Q1[3];
      Q1[3]      = Q1[2];
      Q1[2]      = Q1[1];
      Q1[1]      = Q1[0];
      smooth[6]  = smooth[5];
      smooth[5]  = smooth[4];
      smooth[4]  = smooth[3];
      smooth[3]  = smooth[2];
      smooth[2]  = smooth[1];
      smooth[1]  = smooth[0];
      detrend[6] = detrend[5];
      detrend[5] = detrend[4];
      detrend[4] = detrend[3];
      detrend[3] = detrend[2];
      detrend[2] = detrend[1];
      detrend[1] = detrend[0];
   
      smooth[0]  = (4.0 * Price(i) + 3.0 * Price(i+1) + 2.0 * Price(i+2) + Price(i+3)) / 10.0;
      detrend[0] = (smooth[0]    / 10.0 + 0.5769 * smooth[2]  - 0.5769 * smooth[4]  - smooth[6]  / 10.0) * (0.075 * (domcycle[i+1]) + 0.54);
      Q1[0]      = (detrend[0]   / 10.0 + 0.5769 * detrend[2] - 0.5769 * detrend[4] - detrend[6] / 10.0) * (0.075 * (domcycle[i+1]) + 0.54);
      I1[0]      =  detrend[3];
      JL         = (I1[0]        / 10.0 + 0.5769 * I1[2]      - 0.5769 * I1[4]      - I1[6]      / 10.0) * (0.075 * (domcycle[i+1]) + 0.54);
      JG         = (Q1[0]        / 10.0 + 0.5769 * Q1[2]      - 0.5769 * Q1[4]      - Q1[6]      / 10.0) * (0.075 * (domcycle[i+1]) + 0.54);
      I2[0]      =  I1[0] - JG;
      Q2[0]      =  Q1[0] + JL;
      I2[0]      =  0.20  * I2[0] + 0.80  * I2[1];
      Q2[0]      =  0.20  * Q2[0] + 0.80  * Q2[1];
      Re[0]      =  I2[0] * I2[1] + Q2[0] * Q2[1];
      Im[0]      =  I2[0] * Q2[1] - Q2[0] * I2[1];
      Re[0]      =  0.20  * Re[0] + 0.80  * Re[1];
      Im[0]      =  0.20  * Im[0] + 0.80  * Im[1];
      damp[i]    = MathSqrt(Re[0] * Re[0] + Im[0] * Im[0]) / Point;
      
      if (I1[0] != 0.0) dphase[i] = 180 / Pi * MathArctan(Q1[0] / I1[0]);
      else dphase[i] = 180;
      
      if (Im[0] != 0.0 && Re[0] != 0.0) domcycle[i] = 2.0 * Pi / MathArctan(Im[0] / Re[0]);
      
      if (domcycle[i] > 1.50 * (domcycle[i+1])) domcycle[i] = 1.50 * (domcycle[i+1]);
      if (domcycle[i] < 0.67 * (domcycle[i+1])) domcycle[i] = 0.67 * (domcycle[i+1]);
      if (domcycle[i] < 6.00)   domcycle[i]                 = 6.00;
      if (domcycle[i] > 50.0)   domcycle[i]                 = 50.0;
          domcycle[i] = 0.20 *  domcycle[i]                 + 0.80 * (domcycle[i+1]);
          
          
      if (mode == 1) {
         if (unfiltered) ht[i] = domcycle[i] ;
         else ht[i] = 0.33 * domcycle[i] + 0.67 * (ht[i+1]);
      }
      if (mode == 2) {
         if (unfiltered) ht[i] = damp[i];
         else ht[i] = 0.33 * damp[i]      + 0.67 * (ht[i+1]);
      }
      if (mode == 3) {
         if (unfiltered) ht[i] = dphase[i];
         else ht[i] = 0.33 * dphase[i]    + 0.67 * (ht[i+1]);
      }
      
   }
   return (0);
}

double Price(int shift) {
   double result = (High[shift] + Low[shift]) / 2.0;
   return (result);
}

